<?php
/**
 * @author ElisDN <mail@elisdn.ru>
 * @link http://www.elisdn.ru/blog/58/old-posts-promotion-on-twitter
 * @version 1.0
 */

namespace Parser;

class HTMLPage implements Page
{
	protected $html = '';

	public function load($url) {
		$http = curl_init($url);
		curl_setopt($http, CURLOPT_RETURNTRANSFER, 1);
		$result = curl_exec($http);
		$http_status = curl_getinfo($http, CURLINFO_HTTP_CODE);
		curl_close($http);
		$this->html = $result;
		return $http_status == 200;
	}

	public function getH1() {
		$matches = [];
		if (preg_match('@<h1[^>]*>(?P<value>[^<]*?)</h1>@is', $this->html, $matches)) {
			return $matches['value'];
		}
		return '';
	}

	public function getTitle() {
		$matches = [];
		if (preg_match('@<title>(?P<value>[^<]*?)</title>@is', $this->html, $matches)) {
			return $matches['value'];
		}
		return '';
	}

	public function getDescription() {
		$matches = [];
		if (
			preg_match('@<meta name="description" content="(?P<value>[^"]*?)"\s?/?>@is', $this->html, $matches) ||
			preg_match('@<meta content="(?P<value>[^"]*?)" name="description"\s?/?>@is', $this->html, $matches)
		) {
			return $matches['value'];
		}
		return '';
	}

	public function getKeywords() {
		$matches = [];
		if (
			preg_match('@<meta name="keywords" content="(?P<value>[^"]*?)"\s?/?>@is', $this->html, $matches) ||
			preg_match('@<meta content="(?P<value>[^"]*?)" name="keywords"\s?/?>@is', $this->html, $matches)
		) {
			return $matches['value'];
		}
		return '';
	}
}